
#include "wince.h"
#include "conv.h"

int wce_AToW(const char *a, wchar_t *w)
{
	int length = 0;
	length = _MultiByteToWideChar(CP_ACP, 0, 
		a, -1, NULL, 0);

	if( w == NULL ) return length;

	_MultiByteToWideChar(CP_ACP, 0,
		a, -1,
		w, length);

	return TRUE;
}

int wce_WToA(const wchar_t *w, char *a)
{
	DWORD charlength;

	charlength = _WideCharToMultiByte(CP_ACP, 0, w,
						-1, NULL, 0, NULL, NULL);

	if( a==NULL ) return charlength;

	_WideCharToMultiByte(CP_ACP, 0, w,
		-1, a, charlength, NULL, NULL);

	return TRUE;
}

int _stricmp( const char *s1, const char *s2 )
{
	const char *p1 = s1;
	const char *p2 = s2;

	while( *p1!=_T('\0') && *p2!=_T('\0') ){
		if(*p1 != *p2){
			if( 0x41 <= *p1 && *p1 <=0x5A ){
				if( *p1+0x20 != *p2 )
					return 1;
			}else if( 0x61 <= *p1 && *p1 <=0x7A ){
				if( *p1-0x20 != *p2 )
					return -1;
			}
		}
		p1 = CharNextA(p1); p2 = CharNextA(p2);
		if( *p1==_T('\0') && *p2!=_T('\0') )
			return 1;
		if( *p1!=_T('\0') && *p2==_T('\0') )
			return -1;
	}
	return 0;
}

char *strrchr( const char *s, int c )
{
	const char *p = s, *pp=NULL;

	while(*p!='\0'){
		if( *p == c ) pp = p;
		p = CharNextA(p);
	}
	return (char*)pp;
}

char *CharNextA(const char* a)
{
	char *p=(char *)a;
//	if(TRUE==IsDBCSLeadByteEx(CP_ACP, (BYTE)*a))
	if(TRUE==_IsDBCSLeadByte((BYTE)*a))
		p+=2;
	else
		p++;

	return p;
}

//struct tm *gmtime( time_t *timer )
struct tm *gmtime( time_t *timer )
{
	*timer -= 60*60*9;
	struct tm* time=localtime(timer);

	return time;
}

BOOL DosDateTimeToFileTime(
	WORD dat, WORD tim,
	LPFILETIME f)
{
	SYSTEMTIME s;

	// by uema2.
	s.wYear =      ((dat & 0xFE00)>>9);
	s.wYear += 1980;
	s.wMonth =     (dat & 0x01E0)>>5;
	s.wDay =       dat & 0x001F;
	s.wHour =      (tim & 0xF800)>>11;
	s.wMinute =    (tim & 0x07E0)>>5;
	s.wSecond =    (short)((tim & 0x001F)/2);
	s.wMilliseconds = 0;

	return SystemTimeToFileTime(&s, f);
}

BOOL DeleteFile(LPCSTR file)
{
	static TCHAR tfile[MAX_PATH*2];
	wce_AToW(file, tfile);
	return DeleteFileW(tfile);
}

BOOL CreateDirectory(
  LPCSTR dir,
  LPSECURITY_ATTRIBUTES att)
{
	static TCHAR tdir[MAX_PATH*2];
	wce_AToW(dir, tdir);
	return CreateDirectoryW(tdir, att);
}

BOOL SetFileAttributes(
  LPCSTR file,
  DWORD att)
{
	static TCHAR tfile[MAX_PATH*2];
	wce_AToW(file, tfile);
	return SetFileAttributesW(tfile, att);
}

