
#ifndef _WINCE_H_
#define _WINCE_H_

#include <windows.h>
#include <tchar.h>

#ifndef _TIME_T_DEFINED
typedef long time_t;
//typedef unsigned long time_t;
#define _TIME_T_DEFINED
#endif

//------------- time.h ---------------------
#ifndef _TM_DEFINED
struct tm {
        int tm_sec;     /* seconds after the minute - [0,59] */
        int tm_min;     /* minutes after the hour - [0,59] */
        int tm_hour;    /* hours since midnight - [0,23] */
        int tm_mday;    /* day of the month - [1,31] */
        int tm_mon;     /* months since January - [0,11] */
        int tm_year;    /* years since 1900 */
        int tm_wday;    /* days since Sunday - [0,6] */
        int tm_yday;    /* days since January 1 - [0,365] */
        int tm_isdst;   /* daylight savings time flag */
		int tm_gmtoff; /* ? */
        };
#define _TM_DEFINED
#endif

typedef struct {
		int  yr;        // year of interest
		int  yd;        // day of year 
		long ms;        // milli-seconds in the day 
} transitionTime;

static __int64 wce_GetDeltaSecs(FILETIME f1, FILETIME f2);
static SYSTEMTIME wce_TmToSystemTime(struct tm *t);
static FILETIME wce_YearToFileTime(WORD wYear);
static FILETIME wce_Int64ToFileTime(__int64 iTime);
static time_t wce_SystemTimeToYDay(SYSTEMTIME s);
static struct tm wce_SystemTimeToTm(SYSTEMTIME *s);
static void wce_GetTZBias(int* pTZBiasSecs, int* pDSTBiasSecs);
long wce_GetMessageTime();
static void wce_cvtdate (int trantype, int year, int month, int week, int dayofweek,
			             int date, int hour, int min, int sec, int msec,
						 transitionTime* pDST);
time_t mktime(struct tm* pt);
time_t time( time_t *timer );
struct tm* localtime(const time_t *ptime);
char* wce_ctime( const time_t *ulSecsSince1970 );
//------------- time.h end ------------------

struct tm *gmtime( time_t *timer );

int wce_AToW(const char *a, wchar_t *w);
int wce_WToA(const wchar_t *w, char *a);

int _stricmp( const char *string1, const char *string2 );
#define stricmp _stricmp
char *strrchr( const char *string, int c );

#define lstrcpyn strncpy

BOOL DosDateTimeToFileTime(
  WORD wFatDate, WORD wFatTime,
  LPFILETIME lpFileTime);

#ifdef DeleteFile
#undef DeleteFile
#endif
#ifdef CreateDirectory
#undef CreateDirectory
#endif
#ifdef SetFileAttributes
#undef SetFileAttributes
#endif

BOOL DeleteFile(LPCSTR file);
BOOL CreateDirectory(
	LPCSTR dir,LPSECURITY_ATTRIBUTES attri);
BOOL SetFileAttributes(
	LPCSTR file, DWORD att);


#endif //_WINCE_H_

